/*
 * Created on 04.07.2004
 */
package sineweepwavgenerator;
import java.io.*;
import javax.sound.sampled.*;

/**
 * @author jl
 */
public class SineSweepWavGenerator {

	public static void main(String[] args) {
		try
		{
			final double samplingRate = 44100.0;
			final double length = 5.0; // seconds
			final double startFreq = 20.0;
			final double endFreq = 20000.0;
			
			final int num = (int)(samplingRate*length);
			byte[] buffer = new byte[4*num];
			double alpha = 0.0;
			for(int i = 0; i < num; i++)
			{
				double time = i/samplingRate;
				double freq = startFreq *
					Math.exp(time/length*Math.log(endFreq/startFreq));
				alpha += 2.0*Math.PI*freq/samplingRate;
				short v = (short)(Short.MAX_VALUE*Math.sin(alpha));
			
				buffer[4*i+2] = buffer[4*i  ] = (byte)(v & 0xFF);
				buffer[4*i+3] = buffer[4*i+1] = (byte)(v >> 8);
			}
			
			AudioFormat af = new AudioFormat((float)samplingRate, 16, 2, true, false);
			DataLine.Info cInfo = new Clip.Info(Clip.class, af);
			Clip c = (Clip) AudioSystem.getLine(cInfo);
			c.open(af, buffer, 0, buffer.length);
			c.start();
			c.drain();
						
			InputStream inStream = new ByteArrayInputStream(buffer);
			AudioInputStream auStream = new AudioInputStream(inStream, af, buffer.length/af.getFrameSize());
			File theFile = new File("../../sinesweep.wav");
			AudioSystem.write(auStream, AudioFileFormat.Type.WAVE, theFile);		
		}
		catch(Exception e)
		{
			throw new RuntimeException(e);
		}
		System.exit(0);
	}
}
